<template>
  <b-row class="headerRow" align-v="center">
    <b-col class="file-view-header">
      <div class="d-flex flex-wrap align-items-center">
        <p v-if="resource && resource.displayName" class="h4 m-0">
          {{ resource.displayName }}
        </p>

        <!-- Info Circle -->
        <i-bi-info-circle
          id="resourceDetails"
          :title="$t('page.resource.info')"
          class="mx-1"
        />

        <!-- Resource Settings Button -->
        <b-button
          :title="$t('page.resource.edit')"
          size="sm"
          class="btn-sm mx-1"
          @click="edit"
        >
          <i-bi-pencil-fill :title="$t('page.resource.edit')" />
        </b-button>

        <!-- Upload Button -->
        <b-button
          v-if="!isGuest"
          :title="$t('page.resource.upload')"
          size="sm"
          class="btn-sm mx-1"
          :disabled="isUploading || readOnly || (resource && resource.archived)"
          @click="upload"
        >
          <!-- TODO: Add GitLab branch disabled logic as in MetadataManagerHeader -->
          <i-bi-plus :title="$t('page.resource.upload')" />
        </b-button>

        <!-- Archived badge -->
        <span v-if="resource && resource.archived">
          <b-badge pill variant="warning">{{ $t("default.archived") }}</b-badge>
        </span>
      </div>
    </b-col>

    <!-- Quota Progress Bar -->
    <b-col id="quotaBar" sm="2" class="mx-2">
      <div v-if="reservedQuota !== undefined && usedQuota !== undefined">
        <b-progress
          v-b-popover.hover.bottom="{
            content: $t('page.resource.quotaPopover', {
              used: formatBytes(usedQuota),
              reserved: formatBytes(reservedQuota),
            }),
          }"
          :max="reservedQuota"
          class="w-100 border-1"
          style="background-color: var(--bs-secondary)"
        >
          <b-progress-bar
            :value="usedQuota"
            :variant="usedQuota / reservedQuota >= 0.8 ? 'danger' : 'primary'"
          >
            <strong
              :class="
                usedQuota / reservedQuota < 0.5
                  ? 'justify-content-center d-flex position-absolute progress-w-100'
                  : ''
              "
              class="text-white"
            >
              {{ formatBytes(usedQuota) }} /
              {{ formatBytes(reservedQuota) }}
            </strong>
          </b-progress-bar>
        </b-progress>
      </div>
    </b-col>

    <!-- Search Bar -->
    <b-col sm="2">
      <b-input-group>
        <b-form-input
          id="filterInput"
          v-model="searchTerm"
          type="search"
          size="sm"
          :placeholder="$t('page.resource.typeToSearch')"
        >
        </b-form-input>
      </b-input-group>
    </b-col>

    <!-- Info Popover -->
    <b-popover
      v-if="resource"
      over
      custom-class="filesViewHeaderPopover"
      target="resourceDetails"
      triggers="hover focus"
      placement="bottom"
    >
      <template #title>
        <b>{{ resource.displayName }}</b>
      </template>
      <ul>
        <li v-if="resource.type?.specificType">
          <b>{{ `${$t("page.resource.resourceType")}: ` }}</b>
          {{
            $t("resourceTypes." + resource.type.specificType + ".displayName")
          }}
        </li>
        <li v-if="resource.displayName">
          <b>{{ `${$t("page.resource.displayName")}: ` }}</b>
          {{ resource.displayName }}
        </li>
        <li v-if="resource.pid">
          <b>{{ `${$t("page.resource.PID")}: ` }}</b>
          {{ resource.pid }}
        </li>
        <li v-if="resource.description">
          <b>{{ `${$t("page.resource.description")}: ` }}</b>
          {{ resource.description }}
        </li>
        <li v-if="resource.disciplines && resource.disciplines.length > 0">
          <b>{{ `${$t("page.resource.disciplines")}: ` }}</b>
          <ul>
            <li v-for="discipline in resource.disciplines" :key="discipline.id">
              <span v-if="$i18n.locale === 'de'">
                {{ discipline.displayNameDe }}
              </span>
              <span v-else>
                {{ discipline.displayNameEn }}
              </span>
            </li>
          </ul>
        </li>
        <li v-if="resource.keywords && resource.keywords.length > 0">
          <b>{{ `${$t("page.resource.keywords")}: ` }}</b>
          {{ resource.keywords.join("; ") }}
        </li>
        <li v-if="resource.visibility">
          <b>{{ `${$t("page.resource.visibility")}: ` }}</b>
          {{ resource.visibility.displayName }}
        </li>
        <li v-if="resource.license">
          <b>{{ `${$t("page.resource.license")}: ` }}</b>
          {{ resource.license.displayName }}
        </li>
        <li v-if="resource.usageRights">
          <b>{{ `${$t("page.resource.usageRights")}: ` }}</b>
          {{ resource.usageRights }}
        </li>
        <GitLab
          v-if="
            resource.type?.generalType === coscineResourceTypes.Gitlab.General
          "
          v-model="resource"
        />
      </ul>
    </b-popover>
  </b-row>
</template>

<script lang="ts" setup>
// import the store for current module
import useResourceStore from "../../store";
import useProjectStore from "@/modules/project/store";

import { FileUtil } from "../../utils/FileUtil";
import router from "@/router";

import GitLab from "./resource-type/GitLab.vue";

import { CoscineResourceTypes, QuotaUnit } from "../../types";

const searchTerm = defineModel<string>({ required: true });

defineProps({
  isUploading: {
    default: false,
    type: Boolean,
  },
});

const emit = defineEmits<{
  clickFileSelect: [];
}>();

const resourceStore = useResourceStore();
const projectStore = useProjectStore();

const coscineResourceTypes = CoscineResourceTypes;

const isGuest = computed(() => {
  return projectStore.currentUserRoleIsGuest;
});
const isMember = computed(() => {
  return projectStore.currentUserRoleIsMember;
});
const project = computed(() => {
  return projectStore.currentProject;
});
const resource = computed(() => {
  return resourceStore.currentResource ?? undefined;
});
const resourceTypeInformation = computed(() => {
  return resourceStore.enabledResourceTypes?.find(
    (resourceType) => resourceType.id === resource.value?.type?.id,
  );
});
const readOnly = computed(() => {
  return resourceTypeInformation.value?.resourceContent?.readOnly === true;
});
const usedQuota = computed(() => {
  if (resourceStore.currentResourceQuota?.used) {
    return FileUtil.convertCapacityUnits(
      resourceStore.currentResourceQuota.used,
      QuotaUnit.Byte,
    ); // Bytes
  }
  return undefined;
});
const reservedQuota = computed(() => {
  if (resourceStore.currentResourceQuota?.reserved) {
    return FileUtil.convertCapacityUnits(
      resourceStore.currentResourceQuota.reserved,
      QuotaUnit.Byte,
    ); // Bytes
  }
  return undefined;
});

const edit = () => {
  if (
    resource.value &&
    resource.value.id &&
    project.value &&
    project.value.slug
  ) {
    router.push({
      name: "resource-settings",
      params: {
        slug: project.value.slug,
        guid: resource.value.id,
      },
    });
  }
};

const upload = () => {
  emit("clickFileSelect");
};

const formatBytes = (bytes: number) => {
  return FileUtil.formatBytes(bytes);
};

(async () => {
  if (project.value?.id && resource.value) {
    // Load Quotas for the project if not present - needed for the quota progress bar
    if (
      projectStore.currentResourceTypesQuotas === null &&
      !(isGuest.value || isMember.value)
    ) {
      await projectStore.retrieveResourceTypeQuotas(project.value);
    }
    if (
      !resourceStore.currentResourceQuota &&
      resourceTypeInformation.value?.isQuotaAvailable
    ) {
      // Retrieve quota only if the resource has quota available (e.g. skip for Linked Resource)
      resourceStore.retrieveResourceQuota(project.value.id, resource.value);
    }
  }
})();
</script>

<style scoped>
.headerRow {
  padding: 0px 10px;
}
.file-view-header :deep(p.h4) {
  display: inline-block;
  margin: 0;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  max-width: calc(100% - 11rem);
}
.btn-sm {
  width: 1.75rem;
  height: 1.75rem;
  padding: 0;
}
#resourceDetails {
  width: 1.2em;
  height: 1.2em;
}
#resourceDetails:hover {
  cursor: pointer;
}
.progress {
  height: 1.15rem;
}
.progress-w-100 {
  width: 14%;
}
.sidebar-active .file-view-header :deep(button .unplugin-icon-coscine) {
  width: 1.2em;
  height: 1.2em;
}
.file-view-header :deep(svg) {
  display: flex;
  margin-left: 6px;
  margin-right: 2px;
}
@media (max-width: 1500px) {
  .file-view-header {
    width: calc(100% - 11rem);
  }
  .file-view-header :deep(svg) {
    display: flex;
    margin-left: 6px;
    margin-right: 2px;
  }
  .sidebar-active .file-view-header :deep(button) {
    margin: 0 2px 0px 2px;
  }
  .sidebar-active .file-view-header :deep(button .unplugin-icon-coscine) {
    width: 1.2em;
    height: 1.2em;
  }
  .sidebar-active .btn-sm {
    width: 1.5rem;
    height: 1.5rem;
    padding: 0;
  }
  .sidebar-active .btn-sm :deep(svg) {
    width: 1rem;
    height: 1rem;
    text-align: center;
  }
  #quotaBar {
    display: none;
  }
  .sidebar-active .col-sm {
    max-width: 65%;
    padding-right: 0;
  }
  .sidebar-inactive .file-view-header :deep(p.h4) {
    max-width: calc(100% - 11rem);
  }
  .sidebar-inactive .col-sm {
    max-width: 65%;
    padding-right: 0px;
  }
}
</style>

<style>
.filesViewHeaderPopover {
  padding-left: 0;
  padding-right: 0;
}
</style>
